有人一开始看到Per.js时，会觉得它就是一个普通的JavaScript响应式开发框架，和Vue比几乎完全一样，我并不需要使用它，也不想了解它。如果你也有这样的问题，那么这篇文章也许会让你重新思考这个问题。

**接下来，我就来详细说明一下Per.js的优势与劣势：**

Per和Vue有70%的相似度，那么我们就从他们对比。

首先，性能往往是决定一个框架好坏的最重要的一条，而Per.js的平均执行速度要比Vue快出7到8倍去。（至少在2.3版本之前是这样，之后可能会越来越慢，因为功能越加越多）这就表示当你从服务器里获取20000条数据并使用for属性输出时，使用Vue时的执行时间大约为200ms，而使用Per的执行时间仅有45ms。所以可以说Per.js在for属性上面的执行速度大约是Vue.js的5倍还要多。

仅凭一个for属性的执行速度可能还不足让你信服，那么现在就让我们看看组件的渲染速度。

使用Vue在100个元素中绘制组件大约需要67ms，而使用Per在100个元素中绘制相同组件则只需要1.5ms，这就说明Per.js在渲染组件方面，比Vue要快出大约45倍。

可能你会说，我根本就不用Vue渲染那么多组件，而且Vue虽然比Per.js慢，但是也够用了。

那么如果你这样认为的话，我们就继续来看看Vue和Per.js的数据模板渲染速度。

使用Vue在100个元素中渲染2个变量大约需要58ms，而使用Per执行同样操作则只需要16ms，这就说明Per.js在渲染组件方面，比Vue要快出大约3.5倍。

（以上代码的对比测试详细链接在这里：[Per.js速度对比Vue的传送门](https://gitee.com/skyogo/Per.js/blob/master/%E9%80%9F%E5%BA%A6%E5%AF%B9%E6%AF%94VueJS.md)）

**你可以想象，当你的服务器带宽不足，网站访问极慢时，你可能会考虑以下几种方法：**

1.  增加带宽
2.  重构网站

**第一种方法浪费钱，第二种方法浪费时间，如果都不适合你，那么你可以选择替换框架。**

假设你的用户访问你的网站需要6秒的时间，那么服务器带宽决定了4秒，前端操作浪费了2秒。更何况某些花里胡哨的网站，前端代码几十万行的那种，更需要一个快速的前端框架。

**而我们的作用，就是要解决这个问题。**

Per.js和Vue的操作几乎相同，但是源码100%不同，而且Per.js的部分操作方式和Vue的方式几乎完全一样。更何况它（Per.js）也是渐进式框架，你只需要小修小改即可完成替换。

**有些人又会说，我懒得修改了怎么办呢？**

那么你需要想一想，是浪费你每月大约200块钱好呢，还是重构网站浪费你大约10天时间好呢，还是替换个框架，修改几个api来得实在。

**当然，一个框架的易用性和易上手度是决定这个框架好坏的第二标准，在这一点上，Per.js比Vue也要完美。**

你去码云看看我们的wiki和Vue的官方教程即可知道，使用上手Vue的难度是Per.js难度的几乎3倍还要多，十分不适合某些刚进入前端的小白来使用。

**那么你就可以选择Per.js！**

我们的框架比Vue简单，而且方便，如果你已经学习了Vue也不要紧，我们的框架比Vue要简单几倍，你只需要花费10分钟阅读我们的文档，即可开始体验我们的超级框架！

**那么还有人会问，你们的框架有Vue的全部功能吗？**

**首先你需要知道，我们创建这个框架，不是为了再造一个轮子，而是发展一个新的超级JavaScript响应式框架。这个超级框架，不是为了和Vue一样，主要作用在DOM视图上，而是为了各方面的需求。其中包括：DOM、前端操作、ajax等等。**

我们的框架在DOM方面和Vue一样采用MVC架构；另外我们的框架是模块化的，可扩展的。

这就使得你可以在需要使用时再加载一个Per.js的模块，有效减少了加载时的性能消耗。

**好了，那么最后，看完了这篇文章，相信你自己心里已经有选择了。**

**那么，欢迎下载和使用Per.js！**